#pragma once

//#define OF_ADDON_USING_OFXOPENCV
//#define OF_ADDON_USING_OFXOBJLOADER
//#define OF_ADDON_USING_OFXDIRLIST
//#define OF_ADDON_USING_OFXVECTORMATH
//#define OF_ADDON_USING_OFXNETWORK
//#define OF_ADDON_USING_OFXVECTORGRAPHICS
//#define OF_ADDON_USING_OFXOSC
//#define OF_ADDON_USING_OFXTHREAD
#define OF_ADDON_USING_OFXXMLSETTINGS

#include "ofMain.h"
#include "ofAddons.h"

#include "simpleGuiValue.h"
#include "simpleGuiBaseObject.h"
#include "simpleGuiColor.h"
#include "simpleColor.h"
#include "simpleGuiValue.h"
#include "simpleGuiSlider.h"
#include "simpleGui2DSlider.h"
#include "simpleGuiPanel.h"

//hehe - there is no xml yet!!!
//but we are setting things up for XML

class simpleXmlGui{

	public:

        //----------------------------
        simpleXmlGui(){

   			dragging = false;
        }

        //-----------------------------
        void setup(string panelName, float panelX, float panelY, int defaultSliderWidth = 300){

            panel.setup("testing - right click to move me");
            panel.setPosition(20, 60);
            panel.setElementSpacing(16,16);
            panel.setDimensions(20, 20);

            panel.fgColor.setColor(220, 220, 220, 255);
            panel.fgColor.setSelectedColor(240, 50, 240, 255);

            panel.outlineColor.setColor(255, 255, 255, 180);
            panel.outlineColor.setSelectedColor(255, 255, 255, 255);

            panel.bgColor.setSelectedColor(12, 12, 12, 200);
            panel.bgColor.setColor(24, 24, 24, 200);

        }

        //-------------------------------
        void setSliderWidth(int width){

        }

        //-------------------------------
        void addSliderI(string sliderName, string xmlName, int value , int min, int max, int * attachValue = NULL, void * callbackFunc = NULL){

            //add a new slider to our list
            simpleGuiSlider * tmp = new simpleGuiSlider();
            uiElements.push_back(tmp);

            //setup and dimensions
            tmp->setup(sliderName, value, min, max);
            tmp->setDimensions(180, 10);

            //we can say we want to be an int!
            tmp->setTypeInt();

            tmp->fgColor.setColor(220, 220, 220, 255);
            tmp->fgColor.setSelectedColor(240, 50, 240, 255);
            tmp->outlineColor.setColor(255, 255, 255, 255);
            tmp->bgColor.setColor(12, 12, 12, 100);
            tmp->bgColor.setSelectedColor(24, 24, 24, 255);

            //you can disable text for the object if you want
            //tmp->setShowText(false);
            panel.addElementVertical( tmp );

        }

        //-------------------------------
        void addSliderF(string sliderName, string xmlName, float value , float min, float max, float * attachValue = NULL, void * callbackFunc = NULL){

            //just testing out a 2d slider in here.
            //normally it would be just a 1D slider

            simpleGui2DSlider * tmp = new simpleGui2DSlider();
            uiElements.push_back(tmp);

            tmp->setup(sliderName, value, min, max, value, min, max);
            tmp->setDimensions(120, 40);

            tmp->fgColor.setColor(220, 220, 220, 255);
            tmp->fgColor.setSelectedColor(240, 50, 240, 255);
            tmp->outlineColor.setColor(255, 255, 255, 255);
            tmp->bgColor.setColor(12, 12, 12, 100);
            tmp->bgColor.setSelectedColor(24, 24, 24, 255);

            panel.addElementVertical( tmp );

        }

        //-----------------------------
        void loadSettings(string xmlFile){
            currentXmlFile = xmlFile;
            settings.loadFile(xmlFile);
        }

        //-----------------------------
        void saveSettings(){
            saveSettings(currentXmlFile);
        }

        //-------------------------------
        void saveSettings(string xmlFile){
            settings.saveFile(currentXmlFile);
        }

        //-------------------------------
        void update(){

		}

        //-------------------------------
		void show(){

		}

        //-------------------------------
		void hide(){

		}

        //-------------------------------
		void toggleView(){

		}

        //-------------------------------
		void mouseMoved(float x, float y){
			if(dragging)panel.setPosition(x, y);
			else panel.update(x, y);
		}

        //-------------------------------
		void mousePressed(float x, float y, int button){
			if(button != 0){
			    dragging  = true;
			}else panel.checkHit(x, y);
		}

        //-------------------------------
		void mouseReleased(){
			panel.release();
			dragging = false;
		}

        //-------------------------------
		void keyDown( int key ){

		}

        //-------------------------------
		void keyUp( int key ){

		}

        //-------------------------------
		void draw(){
            ofEnableAlphaBlending();
            panel.render();
		}


        vector <simpleGuiBaseObject * > uiElements;
        simpleGuiPanel panel;

		ofxXmlSettings settings;
		string currentXmlFile;

		int sliderWidth;

		bool dragging;

};


